function report_stock_gral (reporting){
    "use strict";

    var instance = openerp;

    reporting.ReportStockGralWidget = reporting.Base.extend({
        template : 'ReportStockGral',
        stockLocation : [],
        stockQuant : [],
        productProduct : [],
        productTemplate : [],
        productBrand : [],
        productCategory : [],
        product:[],

        events : {
            'click #toolbar > button' : 'clickOnAction',
            'change #current-location': 'fecthSearch',
            'change #current-category' : 'fecthSearch',
            'change #current-brand' : 'fecthSearch',
        },
        init : function(parent){
            this._super(parent);
        },
        start : function(){
            var self = this;
            var dato=[];
            var table = this.$el.find('#table');
            table.bootstrapTable({data : self.productProduct});
            self.fecthInitial();
        },
        // Consulta Inicial
        fecthInitial: function(){
            var self = this;
            self.fecthLocation().then(function(stockLocation){
                self.stockLocation=stockLocation
                return stockLocation;
            }).then(function(stockLocation){
                self.$el.find('#current-location').append('<option value="9999999">Todas las Ubicaciones.</option>');
                _.each(stockLocation,function(item){
                    self.$el.find('#current-location').append('<option value="' + item.id + '">' + item.location_id[1]+" / "+item.name + '</option>');
                });
                return self.fecthStockQuant();
            }).then(function(stockQuant){
                self.stockQuant = stockQuant;
                return self.fecthProduct(stockQuant);
            }).then(function(productProduct){
                self.productProduct = productProduct;
            //     return self.fecthProductTemplate();
            // }).then(function(productTemplate){
            //     self.productTemplate = productTemplate;
                return self.fecthProductBrand();
            }).then(function(productBrand){
                self.productBrand = productBrand;
                self.$el.find('#current-brand').append('<option value="9999999">Todas las marcas</option>');
                _.each(productBrand, function (item) {
                    self.$el.find('#current-brand').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
                return self.fecthCategory();
            }).then(function(productCategory){
                self.productCategory = productCategory;
                self.$el.find('#current-category').append('<option value="9999999">Todas las cat.</option>');
                _.each(productCategory, function (item) {
                    self.$el.find('#current-category').append('<option value="' + item.id + '">' + item.name + '</option>');
            });
            return self.fecthProducto(self.stockQuant, self.stockLocation, self.productBrand);
            });
        },
        // Ubicacion
        fecthLocation : function(){
            var self = this;
            var defer = $.Deferred();
            var location = new instance.web.Model('stock.location');
            var fields = ['id', 'name', 'company_id', 'location_id'];
            var domain =[['active', '=', true],['usage', '=', 'internal']];
            location.query(fields).filter(domain).order_by('id').all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },
        // quant
        fecthStockQuant : function(){
            var self = this;
            var defer = $.Deferred();
            var location = _.flatten(_.map(self.stockLocation,function(item){
                return item.id;
            }));
            var company_id =(_.map(self.stockLocation, function(item){
                return item.company_id[0];
            })).shift();
            var quant = new instance.web.Model('stock.quant');
            var fields = ['id', 'product_id', 'qty', 'cost','location_id'];
            var domain =[['company_id', '=', company_id],['location_id', 'in',location]];
            quant.query(fields).filter(domain).all().then(function(results){
                defer.resolve(results);
            })
            return defer;
        },
        // ProductProduct
        fecthProduct: function(quant){
            var defer = $.Deferred();
            var productIDS = _.flatten(_.map(quant, function (item) {
                return item.product_id[0];
            }));
            var ProductProduct =  new instance.web.Model('product.product');
            var fields = ['id','name', 'standard_price','type','attribute_value_ids','product_brand_id','categ_id'];
            ProductProduct.query(fields).filter([['id', 'in', productIDS]]).all().then(function (results) {
              defer.resolve(results)
            });
            return defer;
        },

        // Buscar Category
        fecthCategory: function () {
            var self = this;
            var defer = $.Deferred();
            var productCategory = new instance.web.Model('product.category');
            productCategory.query(['id', 'name', 'type']).filter([['type', '=', 'normal']]).all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },

        // Buscar marca
        fecthProductBrand: function () {
            var self = this;
            var defer = $.Deferred();
            var productBrand = new instance.web.Model('product.brand');
            productBrand.query(['id', 'name']).filter().all().then(function (results) {
                defer.resolve(results);
            });
            return defer;
        },


        // Verificar si los Valores no son nulos
        valorNull:function(dato){
            var valor ="";
            if (dato){
                valor=dato;
            }
            return valor;
        },


        // Union de objetos
        fecthProducto : function(stockQuant,stockLocation){
            var self = this;
            var stock=[];
            var itemLocation;
            var itemProduct;
            var itemQuant;
            var brand = this.$el.find('#current-brand').val();
            var category = this.$el.find('#current-category').val();
            var productProduct;
            var categ;
            var cat = 0;
            var quant;
            var valuation;
           
            // // console.log(this);
            for (var i = 0; i < stockLocation.length; i++) {
                itemLocation = stockLocation[i];
                productProduct = self.getProductProduct(self.productProduct,stockQuant, itemLocation.id);
                for (var f = 0; f < productProduct.length; f++) {
                    itemProduct = productProduct[f];
                    if(itemProduct.product_brand_id[0] == brand || brand == 9999999){
                        if(itemProduct.categ_id[0] == category || category == 9999999){
                            itemQuant = self.getQuantProduct(itemLocation.id, itemProduct.id, stockQuant);
                            if (itemQuant.length > 0){ 
                                cat = _.reduce(_.map(itemQuant,function(item){
                                return item.qty;
                                }),function(mamo, num){
                                    return mamo + num;
                                },0);
                                quant=itemQuant.shift();
                                valuation = itemProduct.standard_price * cat
                                stock.push({product : quant.product_id[1],
                                            qty : cat,
                                            brand : itemProduct.product_brand_id[1],
                                            category : itemProduct.categ_id[1],
                                            standard_price : accounting.formatNumber(itemProduct.standard_price,2, ".", ","),
                                            valuation : accounting.formatNumber(valuation,2, ".", ","),
                                            location :(itemLocation.location_id[1]+" / "+itemLocation.name)});
                            }
                        }   
                    }
                    
                }
            }
            self.loadTable(stock);
        },
        // Obtener Producto Por quant y locations
        getProductProduct: function(productProduct, stockQuant, location_id){
            var self = this;
            var product_ids= _.flatten(_.map(_.filter(stockQuant,function(item){
                return item.location_id[0] === location_id;
            }),function(map){
                return map.product_id[0];
            }));

            return _.filter(productProduct,function(prod){return _.contains(product_ids, prod.id)});
        },

        // // Obtener  Qaunt  por productos
        getQuantProduct: function(location_id, product_id, quantObjs){
            var self = this;
            var quantProduct = quantObjs;
            if (location_id){
                quantProduct = _.filter(quantProduct, function(item){
                    return item.location_id[0] === location_id;
                });
            }
            if (product_id){
                quantProduct = _.filter(quantProduct, function(item){
                    return item.product_id[0] === product_id;
                });
            }

            return quantProduct;
        },

        // Buscar
        fecthSearch: function(){
            var self = this;
            var location =this.$el.find('#current-location').val();
            var locationObjs = self.stockLocation;
            var quantObjs = self.stockQuant;
            var quant;
            if (location != 9999999){
                locationObjs=_.filter(locationObjs, function (inv){
                    return inv.id == location;
                });
                quantObjs=_.filter(quantObjs, function (inv){
                    return inv.location_id[0] == location;
                });
            }
            self.fecthProducto(quantObjs,locationObjs);
        },
        // Generar la table
        loadTable:function(rowsTable){
            var self = this;
            this.product=rowsTable;
            var table = this.$el.find('#table');
            table.bootstrapTable('load' ,rowsTable);
        },
        // Click pdf -Grafic
        clickOnAction: function (e) {
            var self = this;
            var action = self.$el.find(e.target).val();
            var getColumns=[];
            var rows=[];
            var table = self.$el.find("#table");
            var data2 = table.bootstrapTable('getVisibleColumns');
            if (action === 'pdf') {
                var dataNEW = _.map(data2, function (val){
                    return val.field;
                });
                _.each(self.product,function (item){
                    rows.push(_.pick(item, dataNEW));
                });
              // Obtener los nombre de la Cabecera
                _.each(_.map(data2,function(val){return val}), function(item){
                    getColumns.push([{
                                    title: item.title,
                                    dataKey: item.field
                                }]);
                });
                self.drawPDF(_.flatten(getColumns),rows)
            }
        },
    });
}
